function [cvAcc]=CrossFoldSVM(Data,fold)
%%% Cross Folds validation using SVM Classifier  %%%
%
% Input:  Data: the original samples with class labels for miRNA Data
%         fold: The number of folds required in cross validation
% Ourput: Best Fitness

% clc;
% clear all;

warning('off')

[n d]=size(Data);
tpoints=Data(:,1:d-1);
ttcl=Data(:,d);
vd=[1:n];

CVO = cvpartition(vd,'k',fold);
err = zeros(CVO.NumTestSets,1);
      for i = 1:CVO.NumTestSets
          trIdx = CVO.training(i);
          teIdx = CVO.test(i);
          svmStruct = svmtrain(tpoints(trIdx,:),ttcl(trIdx,:),'kernel_function','rbf');
          pcl = svmclassify(svmStruct,tpoints(teIdx,:)); 
        %  [accuracy(i),precision(i),Sensitivity(i),specificity(i),fmeasure(i),MCC(i),PPV(i)]=validation(ttcl(teIdx,:),pcl);
         accuracy(i)=validation(ttcl(teIdx,:),pcl);
          err(i) = sum(~strcmp(pcl,ttcl(teIdx,:)));
      end
  cvAcc=sum(accuracy)/fold;
  

%    Accuracy_final=sum(accuracy)/fold
%     Precision_final=sum(precision)/fold
%     Sensitivity_final=sum(Sensitivity)/fold
%     Specificity_final=sum(specificity)/fold
%     fmeasure_final=sum(fmeasure)/fold
%     MCC_final=sum(MCC)/fold
%     PPV_final=sum(PPV)/fold
%     test=[ttcl(teIdx,:),pcl]
%      xlswrite('Test.xlsx', test);
 %cvErr = sum(err)/sum(CVO.TestSize)
      
