
function [Best_val,Best_str,feature_index,Best_center,Best_class]=GA_RFCM_Classifier(classifier,numberclass,X_trn, X_tst, Y_trn, Y_tst,param,distType)

returnCode = 0;
pop_size = param(8); % pop_size; Initial population size
no_gen = param(9); % no_gen; number of generation
pcross = param(10); % pcross; crossover probability
pmut = param(11); % pmut; Mutation probability



X_trn1=[];
X_trn1=X_trn;
Y_trn1=[];
Y_trn1=Y_trn;
X_tst1=[];
X_tst1=X_tst;
Y_tst1=[];
Y_tst1=Y_tst;

previousBest_val_all=[];
previousBest_enbsise_all=[];
previousBest_subset_all=[];

n=size(X_trn,1);
d=size(X_trn,2);

%%%  Initial Population Creation  %%%
[init_feature]=initialize_pop(X_trn1,pop_size);

%%%% Initial Fitness Computation %%%%
% fprintf('1st findfitness...\n');
[accuracy_old,center_old,computedCls_old,ms_old,cp_old,returnCode]=findfitness(classifier,init_feature,X_trn1, X_tst1,Y_trn1, Y_tst1,numberclass,distType,param);
population_old = [init_feature center_old];
for i=1:no_gen
   
    %%% Selection   %%%
   [ms_mat,pop_mat,feature_mat,center_mat,computedCls_mat]=selectionGA(ms_old,population_old,init_feature,center_old,computedCls_old);
   
   %%% Crossover  %%%
   [feature_crossover]=crossoverGA(feature_mat,pcross);
   
    %%% Mutation  %%%    
   [feature_mutation]=mutationGA(feature_crossover,pmut);
   
   
    %%% Elitism  %%% 
%    [val,inx]=elitism(ms_mat);
   
%    pop_mutation(pop_size,:)=pop_mat(inx,:);
%    feature_mutation(pop_size,:)=feature_mat(inx,:);
%    center_old(pop_size,:)=center_mat(inx,:);
%    enbsize_dec_mutation(pop_size,:)=enbsize_dec_mat(inx,:);
   
   %%%% Final Fitness Computation %%%%
%    fprintf('2nd findfitness...\n');
   [accuracy_mutation,center_mutation,computedCls_mutation,ms_mutation,cp_mutation,returnCode]=findfitness(classifier,feature_mutation,X_trn1, X_tst1,Y_trn1, Y_tst1,numberclass,distType,param);

   
   %%% Validation of Results  %%%
    [currentBest_val,inx]=elitism(ms_mat);
    currentBest_str=feature_mat(inx,:);
    currentBest_center=center_mat(inx,:);
    currentBest_class=computedCls_mat(:,inx);
    if (i==1)
        previousBest_val = currentBest_val;
        previousBest_str = currentBest_str;
        previousBest_center = currentBest_center;
        previousBest_class = currentBest_class;
    else
        if (currentBest_val < previousBest_val)
            previousBest_val = currentBest_val;
            previousBest_str = currentBest_str;
            previousBest_center = currentBest_center;
            previousBest_class = currentBest_class;
        end
    end
    
    currentBest_str_all(i,:)=currentBest_str;
    currentBest_val_all(i,:)=currentBest_val;
    currentBest_center_all(i,:)=currentBest_center;
    currentBest_class_all(:,i)=currentBest_class;
    
    previousBest_str_all(i,:)=previousBest_str; 
    previousBest_val_all(i,:)=previousBest_val;
    previousBest_center_all(i,:)=previousBest_center;
    previousBest_class_all(:,i)=previousBest_class;
    
    population_old = [feature_mutation center_mutation];
    init_feature = feature_mutation;
    ms_old=ms_mutation;
    center_old = center_mutation;
    computedCls_old = computedCls_mutation;    
    
    
    
   %%% Printing of Results  %%%
   fprintf('Gen-%d# , Active features: %d, Best Fit: %.4f',i, sum(previousBest_str,2), previousBest_val);
   fprintf('\n');
   
end

sheetname = strcat(classifier,'_',distType);
writeToExcel('./Metric/','FeaturesBestEachGen',currentBest_str_all,currentBest_val_all,sheetname);
writeToExcel('./Metric/','FeaturesBestTillEachGen',previousBest_str_all,previousBest_val_all,sheetname);
final_gen=i;

[Best_val,Best_inx]=min(previousBest_val_all);
Best_str=previousBest_str_all(Best_inx,:);
% Best_val=previousBest_val;
Best_center=previousBest_center_all(Best_inx,:);
Best_class = previousBest_class_all(:,Best_inx);
feature_index=find(Best_str);
%%% Printing of Summery  %%%

   fprintf('============SUMMERY===========\n');
   fprintf('Original no. of Features: %d\t',size(Best_str,2));
   fprintf('Selected no. of Features: %d\n',size(feature_index,2));
   fprintf('Selected Feature indices:\n')
   fprintf('%d\t',feature_index);
   fprintf('\n');
  end

  
function writeToExcel(folderName,fileName,feature_str,fitness_val,xlSheet)
	xlFile = strcat(folderName,fileName);
    dataVal = [feature_str sum(feature_str,2) fitness_val];

	xlswrite(xlFile,dataVal,xlSheet,'A1');
end