function [U_RFCMRF,clusRFCMRF,centerRFCMRF,returnCode] = RFCM_RF(data,nofCluster,m1,mItr,epsi,wlow,center,distType,noTree)


loopflag = 1;
loopRetry = 20;
		%-------------------------------------------------------------------------------------------------------------------------
%         center
		%fprintf('RFCM_RF: Processing RFCM method....\n');	
	while(loopflag == 1 && loopRetry > 0)	

        [U,J,centerRFCM,returnCode]=RFCM(data,nofCluster,m1,mItr,epsi,wlow,center,distType);
        if(returnCode == 1)            
            return;
        end
        %fprintf('Returend U from RFCM..\n');
        %U
        [UCrisp,URough] = getCrispRough(U);
        cardCrispRFCM = sum(sum(UCrisp));
        [clusCrispRFCM,ci] = find(UCrisp == 1);
        if (length(clusCrispRFCM) >= 1)
            loopflag = 0;
        else 
            loopflag = 1;
        end
        loopRetry = loopRetry - 1;
    end
%     centerRFCM
     %unique(clusCrispRFCM)
     %fprintf('Loop try = %d\t, Cluster length = %d\n',loopRetry,length(clusCrispRFCM));
    
        dataCrispRFCM = data(ci,1:end);  % get only data of all lower approximation
%         [ri,ci] = find(URough == 1);
%         ci = unique(ci);
        
        %-------------------------------------------------------------------------------------------------------------------------
        if (length(unique(clusCrispRFCM))>1)
        
        fprintf('RFCM_RF: Processing RFCM method with RF....\n');
			
		%fprintf('RFCM_RF: training...\n');
        cd .\randomforest-matlab\RF_Class_C\;
        model_class = classRF_train(dataCrispRFCM,clusCrispRFCM,noTree);
        clusRFCMRF = [];
        clusRFCMRF = classRF_predict(data(:,1:end),model_class);
        cd ..
        cd ..
        else
            fprintf('RFCM_RF: Skipping RF as only one cluster...\n');
            clusRFCMRF = clusCrispRFCM;
%             nofCluster = length(unique(clusCrispRFCM));
        end
		% Compute membership matrix for final class
        U_RFCMRF = zeros(size(clusRFCMRF,1),nofCluster);
        temp1 = (clusRFCMRF - 1)*size(clusRFCMRF,1);
        temp2 = temp1 + [1:size(clusRFCMRF,1)]';
        U_RFCMRF(temp2) = 1;
        % Compute membership matrix for final class
        
        U_RFCMRF = U_RFCMRF';
        centerRFCMRF = calculateMean(data(:,1:size(data,2)),U_RFCMRF,m1);
        
		% [maxU,g] = max(U_RFK,[],1);
        % clusRFK = g';
		%-------------------------------------------------------------------------------------------------------------------------

end


function [C] = calculateMean(data,U,m)
	u_fuzzi = U.^m;
%     fprintf('Size of u_fuzzy');
     %size(u_fuzzi)
     %size(data)
     %sum(u_fuzzi')
	C =  (u_fuzzi*data)./((ones(size(data, 2), 1)*sum(u_fuzzi'))');	
end	% end function calculateMean


function [UCrisp,URough] = getCrispRough(U)
    UCrisp = (U == 1);
    URough = (U < 1 & U > 0);
end % end function getCrispRough


