function [cp,CrossCP,accuracy,precision,sensitivity,specificity,fmeasure,MCC,PPV]=findfitnessFS(inx_feature,points,tcl,fold)
%function [cp]=findfitnessFS(inx_feature,points,tcl,fold)
%%%% FITNESS COMPUTATION  %%%%
%
% Input:  inx_feature: Initial feature indices
%         points: The original sample
%         tcl: Class labels
%         fold: The number of folds required in cross validation
%                                
% Ourput: Classification Accuracy or Fitness 
%         Best precision, Sensitivity, Specificity, fmeasure, MCC, PPV
         
% clc;
% clear all;

epsi = 1e-5; %epsilon
fuzzifier = 2; %fuzzifier
maxItr = 10; %maxItr	
wlow = 0.95; %wlow
noTree = 1000; % No. of Tree for RF
numberclass = length(unique(tcl));


 tempData=[];
 feature=[];
 feature=inx_feature;

for i=1:size(feature,1) 
    tempData=points(:,feature(i,:));
    
    % 1 - Compute Clustering Objective
    distType = 'Euclidean';
    randPermutation = randperm(size(tempData,1));
    randIndex = sort(randPermutation(1:numberclass));
    tempCenter = tempData(randIndex,:); % select center from data
%     tempFeature = repmat(feature(i,:),numberclass,1);
%     tempCenter = tempCenter.*tempFeature; % keep only selected features in center
    [U_RFCMRF,clusRFCMRF,centerRFCMRF,returnCode]=RFCM_RF(tempData,numberclass,fuzzifier,maxItr,epsi,wlow,tempCenter,distType,noTree);
    [cp(i),ms(i)]=pmetNew(tcl,clusRFCMRF);
    
    % 2 - Compute Classification Objective for same features
    [CrossCP(i),accuracy(i),precision(i),sensitivity(i),specificity(i),fmeasure(i),MCC(i),PPV(i)]=CrossFold_PSO(tempData,tcl,fold);
 end
end
