function [dist] = getDist(center, data,distType)
    %getPearson = corr(data',center','type','Pearson');
    switch(distType)
            case 'Euclidean'
                dist=distfcm(center, data);
            case 'Pearson'
                dist = pdist2(center,data,'correlation'); 
            case 'Spearman'
                dist = pdist2(center,data,'Spearman'); 
            case 'BioSim'
                for i = 1:size(center,1)
                    for j = 1:size(data,1)
                        [dist(i,j)] = BioSimMod(center(i,:)',data(j,:)');
                    end
                end                
            otherwise
                fprintf('Invalid distance type\n' );
        
    end
    
end