function [] = plotRFCM_RF()
    [Data,c_txt,c_raw] = xlsread('BRCAFINAL.xlsx','BRCA');
    data=Data(:,1:end-1);
    tcl=Data(:,end);
    distType = 'Euclidean';
    numberclass = length(unique(tcl));
    fuzzifier = 2; %fuzzifier
    epsi = 1e-5; %epsilon
    maxItr = 10; %maxItr	
    wlow = 0.95; %wlow
    noTree = 1000; % No. of Tree for RF
    randPermutation = randperm(size(data,1));
    randIndex = sort(randPermutation(1:numberclass));
    tempCenter = data(randIndex,:);
    [U_RFCMRF,clusRFCMRF,centerRFCMRF,returnCode]=RFCM_RF(data,numberclass,fuzzifier,maxItr,epsi,wlow,tempCenter,distType,noTree);
    
    %Plot ROC
    [tpr,fpr,th] = roc(tcl',clusRFCMRF');
    plotroc(tcl',clusRFCMRF');
    
    
    
    %Plot clustergram
    mirna=c_txt(1,2:end-1);
    patient=c_txt(2:size(c_txt(:,1)),1);
    data_nw = data(:,1:end-1);
    cgo=clustergram(data_nw','Standardize','column');
    set(cgo,'RowLabels',mirna,'ColumnLabels',patient);
end